// BonTuner.h: CBonTuner NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(_BONTUNER_H_)
#define _BONTUNER_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "IBonDriver.h"
#include "USBIO.h"

class CBonTuner : public IBonDriver
{
public:
	CBonTuner();
	virtual ~CBonTuner();

	const BOOL OpenTuner(void);
	void CloseTuner(void);

	const BOOL SetChannel(const BYTE bCh);
	const float GetSignalLevel(void);

	const DWORD WaitTsStream(const DWORD dwTimeOut = 0);
	const DWORD GetReadyCount(void);

	const BOOL GetTsStream(BYTE *pDst, DWORD *pdwSize, DWORD *pdwRemain);
	const BOOL GetTsStream(BYTE **ppDst, DWORD *pdwSize, DWORD *pdwRemain);

	void PurgeTsStream(void);

	void Release(void);

	static CBonTuner * m_pThis;
	static HINSTANCE m_hModule;

protected:
	// ŒI/ONGXgwb_
	#pragma pack(1)
	struct FixedIoReqHead
	{
		BYTE bDevice;		// foCXID
		DWORD dwIoCode;		// I/ORg[R[h
		WORD wTxdSize;		// Mf[^TCY
		WORD wRxdSize;		// Mf[^TCY
	};
	#pragma pack()

	// I/ONGXgL[f[^
	struct AsyncIoReq
	{
		OVERLAPPED OverLapped;
		DWORD dwState;
		DWORD dwDevice;
		DWORD dwIoCode;
		DWORD dwTxdSize;
		DWORD dwRxdSize;
		BYTE TxdBuff[64];
		BYTE RxdBuff[65536];
		AsyncIoReq *pNext;
	};

	const BOOL GetDriverPath(GUID *pGuid, LPSTR lpszPath);
	const int SendIoRequest(const BYTE bDevice, const DWORD dwIoCode, BYTE *pTxdData, const DWORD dwTxdSize, BYTE *pRxdData, const DWORD dwRxdSize);
	const BOOL SendFixedRequest(const UINT nID);

	AsyncIoReq * AllocIoReqBuff(const DWORD dwBuffNum);
	void FreeIoReqBuff(AsyncIoReq *pBuff);

	static DWORD WINAPI PushIoThread(LPVOID pParam);
	static DWORD WINAPI PopIoThread(LPVOID pParam);

	const BOOL PushIoRequest(const BYTE bDevice, const DWORD dwIoCode, BYTE *pTxdData, const DWORD dwTxdSize, const DWORD dwRxdSize);
	const BOOL PopIoRequest(void);

	BYTE m_TxdBuff[256];
	BYTE m_RxdBuff[256];

	AsyncIoReq *m_pIoReqBuff;
	AsyncIoReq *m_pIoPushReq;
	AsyncIoReq *m_pIoPopReq;
	AsyncIoReq *m_pIoGetReq;

	DWORD m_dwBusyReqNum;
	DWORD m_dwReadyReqNum;

	HANDLE m_hPushIoThread;
	HANDLE m_hPopIoThread;
	BOOL m_bLoopIoThread;

	HANDLE m_hOnStreamEvent;

	CRITICAL_SECTION m_CriticalSection;

	// ǉ byMeru(2008/03/27)
	SOCKET m_sock;
};

#endif // !defined(_BONTUNER_H_)
